package datasets;

import org.lwjgl.input.Keyboard;
import org.lwjgl.util.vector.Vector3f;

import utilities.MNMatrix;

public class Projection {
	
	private int nRows; //for datapoints matrix..
	private static int nCols;
	
	private static float[] angles;
	
	private static MNMatrix rotationMatrix; 
	
	private static MNMatrix matrix;
	
	public Projection(int nRows, int nCols) {
		this.nRows = nRows;
		this.nCols = nCols;
		angles = new float[nCols];
		this.matrix = createProjectionMatrix();
		this.rotationMatrix = new MNMatrix(nCols, nCols);
		rotationMatrix.fillEmptyMatrix();
		updateRotationMatrix(rotationMatrix);
	}
	
	MNMatrix createProjectionMatrix() {
		MNMatrix projectionMatrix = new MNMatrix(3,nCols);
		projectionMatrix.fillEmptyMatrix();
		for (int r = 0; r < 3; r++) {
			for (int c = 0; c < nCols; c++) {
					projectionMatrix.setValue(r,c,(r==c) ? 1f : 0f);
			}
		}
		return projectionMatrix;
	}
	
	public static void manipulateProjectionMatrix(int key) {
		MNMatrix m = new MNMatrix(3,nCols);
		m.fillEmptyMatrix();
		
		if (key >= 16 && key <= 25) {
			if (key-16 >= nCols) return;
			angles[key-16] += 0.01f;
		}
		if (key >= 30 && key <= 39) {
			if (key-30 >= nCols) return;
			angles[key-30] -= 0.01f;
		}
		
		updateRotationMatrix(rotationMatrix);
		matrix = rotationMatrix;
	}
	
	private static void updateRotationMatrix(MNMatrix m) {
		 //= 
		
		for (int r = 0; r < m.getRows(); r++) {
			for (int c = 0; c < m.getCols(); c++) {
				m.setValue(r, c, (r==c) ? 1 : 0);
			}
		}
		
		if (false) {
			m.setValue(0, 0, (float)(Math.cos(angles[1])*Math.cos(angles[2])));
			m.setValue(0, 1, (float)(Math.sin(angles[0])*Math.sin(angles[1])*Math.cos(angles[2])+Math.cos(angles[0])*Math.sin(angles[2])));
			m.setValue(0, 2, (float)((-Math.cos(angles[0]))*Math.sin(angles[1])*Math.cos(angles[2])+Math.sin(angles[0])*Math.sin(angles[2])));
			m.setValue(1, 0, (float)((-Math.cos(angles[1]))*Math.sin(angles[2])));
			m.setValue(1, 1, (float)((-Math.sin(angles[0]))*Math.sin(angles[1])*Math.sin(angles[2])+Math.cos(angles[0])*Math.cos(angles[2])));
			m.setValue(1, 2, (float)((Math.cos(angles[0]))*Math.sin(angles[1])*Math.sin(angles[2])+Math.sin(angles[0])*Math.cos(angles[2])));
			m.setValue(2, 0, (float)Math.sin(angles[1]));
			m.setValue(2, 1, (float)((-Math.sin(angles[0]))*Math.cos(angles[1])));
			m.setValue(2, 2, (float)(Math.cos(angles[0])*Math.cos(angles[1])));
			
			m.transpose();
		}
	}
	
	public MNMatrix getMatrix() {
		return matrix;
	}
	public static float[] passAngles(){
		return angles;
	};
}
