package main;


import org.lwjgl.opengl.Display;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Random;

import assets.Grid;
import assets.ViewControl;
import datasets.DataFileReader;
import datasets.Dataset;
import display.DisplayRenderer;
import renderer.Loader;
import renderer.MainRenderer;


public class MainLoop {

	public static void main(String args[]) {
		DisplayRenderer.initialize();

		Loader loader = new Loader();
		ViewControl camera = new ViewControl();
		Grid ac = new Grid(loader);
		MainRenderer renderer = new MainRenderer(loader);	
				
		Dataset data = DataFileReader.loadDataset("data", loader);
		
		/******* Some code to randomly generate 1000 data points ******
		try{
			PrintWriter writer = new PrintWriter("res/data2.txt", "UTF-8");
		    writer.println("1000,10");
		       
		    Random randomGenerator = new Random();
			for (int idx = 1; idx <= 10000; ++idx){
			      float randomF = randomGenerator.nextFloat();
			      randomF *= 2;
			      randomF -= 1;
			      randomF *= 4;
			      if (idx % 10 == 0 && idx > 0)  writer.print(randomF + "\n"); else writer.print(randomF + ",");
			}
			writer.close();
		}
		catch (IOException e) {
			   return;
		}
		*/
		
		while(!Display.isCloseRequested()) {
			camera.move(data);
			renderer.render(ac, data, camera);
			DisplayRenderer.update();
		}
        
		loader.cleanUp();
		renderer.cleanUp();
		Display.destroy();
        
		return;
		}
}
